#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <stdint.h>
#include <libdragon.h>
#include "libgbpak.h"

static resolution_t res = RESOLUTION_320x240;
static bitdepth_t bit = DEPTH_32_BPP;


int main(void)
{
    /* enable interrupts (on the CPU) */
    init_interrupts();

    /* Initialize peripherals */
    display_init( res, bit, 2, GAMMA_NONE, ANTIALIAS_RESAMPLE );
    console_init();
    controller_init();

    console_set_render_mode(RENDER_MANUAL);


    uint8_t rdata[32];
    memset( rdata, 0, 32 );


	console_clear();
	controller_scan();


	printf( "\n\nlibgbpak test-program\n" );
 
    int controllers = get_controllers_present();

	printf( "Controller 1 %spresent\n", (controllers & CONTROLLER_1_INSERTED) ? "" : "not " );
	printf("\n");
 
	//int ret=0;
 
	//init
	//init_gbpak();
	int error =  init_gbpak();
	printf( "init_gbpak %d\n", error);
	
	extern cart gbcart;

if(error==0){	
	printf("title: %s\n", gbcart.title);
	printf("mapper: %.02x\n", gbcart.mapper);
	printf("rombanks: %d\n", gbcart.rombanks);
	printf("rambanks: %d\n", gbcart.rambanks);
	printf("romsize: %d\n", gbcart.romsize);	
	printf("romsize kb: %d\n", (gbcart.romsize/1024));		
	printf("ramsize: %i\n", gbcart.ramsize);
	
	//uint8_t rom_data[gbcart.romsize];
	//printf("dump: %i\n", copy_gbRom_toSDRAM(rom_data));
	printf("ramsize: %i\n", gbcart.battery);
	printf("rtc: %i\n", gbcart.rtc);
	printf("rumble: %i\n", gbcart.rumble);
	printf("sgb: %i\n", gbcart.sgb);
	printf("gbc: %i\n", gbcart.gbc);	         

	
	
}
else{
printf("error please clean connector and restart console");
}



 console_render();


	printf( "\n" );
	console_render();


}
