/*
 * transferpak debug simulation
 * code taken from: http://sourceforge.net/p/nragev20/code/HEAD/tree/trunk/
 * 
 */


#include <stdio.h>
#include <string.h>
#include <stdint.h>

int iCurrentBankNo=0, iCurrentRamBankNo=0;
int bRamEnableState=0;
int iCurrentRomBankNo=0;
int iNumRamBanks=4, iNumRomBanks=999;
int bMBC1RAMbanking=0;
int iEnableState=1;
int iCurrentAccessMode=0;
int bHasTimer=0;
int iAccessModeChanged=0;
int bHasRam=1;
	uint8_t Data[32];
#define true 1
#define false 0



int WriteCartMBC2(uint16_t dwAddress, uint8_t *Data)
{
	switch (dwAddress >> 13)
	{
	case 0: //	if ((dwAddress <= 0x1FFF)) // We shouldn't be able to read/write to RAM unless this is toggled on
		bRamEnableState = (Data[0] == 0x0A);
		printf("Set RAM enable: %d\n", bRamEnableState);
		break;
	case 1: //	else if ((dwAddress >= 0x2000) && (dwAddress <= 0x3FFF)) // ROM bank select
		iCurrentRomBankNo = Data[0] & 0x0F;
		if (iCurrentRomBankNo == 0) {
			iCurrentRomBankNo = 1;
		}
		printf("Set ROM Bank: %02X\n", iCurrentRomBankNo);
		break;
	case 2: //	if ((dwAddress >= 0x4000) && (dwAddress <= 0x5FFF)) // RAM bank select
		if (bHasRam) {
			iCurrentRamBankNo = Data[0] & 0x07;
			printf("Set RAM Bank: %02X\n", iCurrentRamBankNo);
		}
		break;
	case 5: //	else if ((dwAddress >= 0xA000) && (dwAddress <= 0xBFFF) && bRamEnableState) // Write to RAM
		if (bHasRam) {
			printf("RAM write: Bank %02X\n", iCurrentRamBankNo);
			//CopyMemory(&RamData[dwAddress - 0xA000 + (iCurrentRamBankNo << 13)], Data, 32);
		}
		break;
	default:
		printf("Bad write to MBC2 cart, address %04X\n", dwAddress);
	}

	return true;
}


int WriteCartMBC3(uint16_t dwAddress, uint8_t *Data)
{
	int i;

	switch (dwAddress >> 13)
	{
	case 0: //	if ((dwAddress <= 0x1FFF)) // We shouldn't be able to read/write to RAM unless this is toggled on
		bRamEnableState = (Data[0] == 0x0A);
		printf("Set RAM enable: %d\n", bRamEnableState);
		break;
	case 1: //	else if ((dwAddress >= 0x2000) && (dwAddress <= 0x3FFF)) // ROM bank select
		iCurrentRomBankNo = Data[0] & 0x7F;
		if (iCurrentRomBankNo == 0) {
			iCurrentRomBankNo = 1;
		}
		printf("Set Rom Bank: %02X\n", iCurrentRomBankNo);
		break;
	case 2: //	if ((dwAddress >= 0x4000) && (dwAddress <= 0x5FFF)) // RAM/Clock bank select
		if (bHasRam) {
			iCurrentRamBankNo = Data[0] & 0x03;
			printf("Set RAM Bank: %02X\n", iCurrentRamBankNo);
			if (bHasTimer && (Data[0] >= 0x08 && Data[0] <= 0x0c)) {
				// Set the bank for the timer
				iCurrentRamBankNo = Data[0];
			}
		}
		break;
	case 3: //	else if ((dwAddress >= 0x6000) && (dwAddress <= 0x7FFF)) // Latch timer data
		//CopyMemory(LatchedTimerData, TimerData, 5 * sizeof(TimerData[0]));
		if (Data[0] & 1) {
			// Update timer, save latch values, and set latch state
			//UpdateRTC(Cart);
		//	for (i=0; i<4; i++)
			//	LatchedTimerData[i] = TimerData[i];
			//TimerDataLatched = true;
			printf("Timer Data Latch: Enable\n");
		} else {
		//	TimerDataLatched = false;
			printf("Timer Data Latch: Disable\n");
		}
		break;
	case 5: //	else if ((dwAddress >= 0xA000) && (dwAddress <= 0xBFFF)) // Write to RAM
		if (bHasRam) {
			if (iCurrentRamBankNo >= 0x08 && iCurrentRamBankNo <= 0x0c) {
				// Write to the timer
				printf("Timer write: Bank %02X\n", iCurrentRamBankNo);
			//	TimerData[iCurrentRamBankNo - 0x08] = Data[0];
			} else {
				printf("RAM write: Bank %02X%s\n", iCurrentRamBankNo, bRamEnableState ? "" : " -- NOT ENABLED (but wrote anyway)");
			//	CopyMemory(&RamData[dwAddress - 0xA000 + (iCurrentRamBankNo * 0x2000)], Data, 32);
			}
		}
		break;
	default:
		printf("Bad write to MBC3 cart, address %04X\n", dwAddress);
	}

	return true;
}

int WriteCartMBC5(uint16_t dwAddress, uint8_t *Data)
{
	switch (dwAddress >> 13)
	{
	case 0: //	if ((dwAddress <= 0x1FFF)) // We shouldn't be able to read/write to RAM unless this is toggled on
		bRamEnableState = (Data[0] == 0x0A);
		printf("Set RAM enable: %d\n", bRamEnableState);
		break;
	case 1: //	else if ((dwAddress >= 0x2000) && (dwAddress <= 0x2FFF)) // ROM bank select, low bits
		iCurrentRomBankNo &= 0xFF00;
		iCurrentRomBankNo |= Data[0];
		// iCurrentRomBankNo = ((int) Data[0]) | (iCurrentRomBankNo & 0x100);
		printf("Set ROM Bank: %02X\n", iCurrentRomBankNo);
		break;
	case 2: //	else if ((dwAddress >= 0x3000) && (dwAddress <= 0x3FFF)) // ROM bank select, high bit
		iCurrentRomBankNo &= 0x00FF;
		iCurrentRomBankNo |= (Data[0] & 0x01) << 8;
		// iCurrentRomBankNo = (iCurrentRomBankNo & 0xFF) | ((((int) Data[0]) & 1) * 0x100);
		printf("Set ROM Bank: %02X\n", iCurrentRomBankNo);
		break;
	case 3: //	if ((dwAddress >= 0x4000) && (dwAddress <= 0x5FFF)) // RAM bank select
		if (bHasRam) {
			iCurrentRamBankNo = Data[0] & 0x0F;
			printf("Set RAM Bank: %02X\n", iCurrentRamBankNo);
		}
		break;
	case 5: //	else if ((dwAddress >= 0xA000) && (dwAddress <= 0xBFFF)) // Write to RAM
		if (bHasRam) {
			if (iCurrentRamBankNo >= iNumRamBanks) {
				printf("RAM write: Buffer error on ");
				printf("%02X", iCurrentRamBankNo);
				printf("\n");
			} else {
				printf("RAM write: Bank %02X\n", iCurrentRamBankNo);
				//CopyMemory(&RamData[dwAddress - 0xA000 + (iCurrentRamBankNo << 13)], Data, 32);
			}
		}
		break;
	default:
		printf("Bad write to MBC5 cart, address %04X\n", dwAddress);
	}

	return true;
}


int ReadCartMBC5(uint16_t dwAddress, uint8_t *Data)
{
	switch (dwAddress >> 13)
	{
	case 0:
	case 1: //	if ((dwAddress <= 0x3FFF))
		//CopyMemory(Data, &RomData[dwAddress], 32);
		printf("Nonbanked ROM read - MBC5\n");
		break;
	case 2:
	case 3: //	else if ((dwAddress >= 0x4000) && (dwAddress <= 0x7FFF))
		if (iCurrentRomBankNo >= iNumRomBanks) {
			//ZeroMemory(Data, 32);
			printf("Banked ROM read: (Banking Error)");
			printf("%02X",iCurrentRomBankNo);
			printf(" (int=%d)\n",iCurrentRomBankNo);
		} else {
			//CopyMemory(Data, &RomData[dwAddress - 0x4000 + (iCurrentRomBankNo << 14)], 32);
			printf("Banked ROM read: Bank=");
			printf("%02X",iCurrentRomBankNo);
			printf(" (int=%d)\n",iCurrentRomBankNo);
		}
		break;
	case 5: //	else if ((dwAddress >= 0xA000) && (dwAddress <= 0xBFFF))
		if (bHasRam) {
			if (iCurrentRamBankNo >= iNumRamBanks) {
				//ZeroMemory(Data, 32);
				printf("Failed RAM read: (Banking Error) %02X\n", iCurrentRamBankNo);
			} else {
				//CopyMemory(Data, &RamData[dwAddress - 0xA000 + (iCurrentRamBankNo << 13)], 32);
				printf("RAM read: Bank %02X\n", iCurrentRamBankNo);
			}
		} else {
			//ZeroMemory(Data, 32);
			printf("Failed RAM read: (RAM Not Present)\n");
		}
		break;
	default:
		printf("Bad read from MBC5 cart, address %04X\n", dwAddress);
	}

	return true;
}

int ReadCartMBC3(uint16_t dwAddress, uint8_t *Data)
{
	int i;

	switch (dwAddress >> 13)
	{
	case 0:
	case 1: //	if ((dwAddress <= 0x3FFF))
		//CopyMemory(Data, &RomData[dwAddress], 32);
		printf("Nonbanked ROM read - MBC3\n");
		break;
	case 2:
	case 3: //	else if ((dwAddress >= 0x4000) && (dwAddress <= 0x7FFF))
		if (iCurrentRomBankNo >= iNumRomBanks) {
		//	ZeroMemory(Data, 32);
			printf("Banked ROM read: (Banking Error) %02X\n", iCurrentRomBankNo);
		} else {
			//CopyMemory(Data, &RomData[dwAddress - 0x4000 + (iCurrentRomBankNo * 0x4000)], 32);
			printf("Banked ROM read: Bank %02X\n", iCurrentRomBankNo);
		}
		break;
	case 5: //	else if ((dwAddress >= 0xA000) && (dwAddress <= 0xBFFF))
		
		if (bHasTimer && (iCurrentRamBankNo >= 0x08 && iCurrentRamBankNo <= 0x0c)) {
			// w00t! the Timer was just read!!
			/*
			if (TimerDataLatched) {
				for (i=0; i<32; i++)
					Data[i] = LatchedTimerData[iCurrentRamBankNo - 0x08];
			} else {
				UpdateRTC(Cart);
				for (i=0; i<32; i++)
					Data[i] = TimerData[iCurrentRamBankNo - 0x08];
			}
			* */
			printf("rtc\n");
		}
		else if (bHasRam) {
			if (iCurrentRamBankNo >= iNumRamBanks) {
			//	ZeroMemory(Data, 32);
				printf("Failed RAM read: (Banking Error) %02X\n", iCurrentRamBankNo);
			}
			else {
			//	CopyMemory(Data, &RamData[dwAddress - 0xA000 + (iCurrentRamBankNo * 0x2000)], 32);
				printf("RAM read: Bank %02X\n", iCurrentRamBankNo);
			}
			//else {
			//	ZeroMemory(Data, 32);
			//	//for (i=0; i<32; i++) Data[i] = 0;
			//	printf("Failed RAM read: (RAM not active)\n");
			//}
		} else {
			//ZeroMemory(Data, 32);
			printf("Failed RAM read: (RAM not present)\n");
		}
		break;
	default:
		printf("Bad read from MBC3 cart, address %04X\n", dwAddress);
	}

	return true;
}


int ReadCartMBC2(uint16_t dwAddress, uint8_t *Data)
{
	switch (dwAddress >> 13)
	{
	case 0:
	case 1: // if ((dwAddress <= 0x3FFF))
		//CopyMemory(Data, &RomData[dwAddress], 32);
		printf("Nonbanked ROM read - MBC2\n");
		break;
	case 2:
	case 3:	//	else if ((dwAddress >= 0x4000) && (dwAddress <= 0x7FFF))
		if (iCurrentRomBankNo >= iNumRomBanks) {
			//ZeroMemory(Data, 32);
			printf("Banked ROM read: (Banking Error) %02X\n", iCurrentRomBankNo);
		} else {
			//CopyMemory(Data, &RomData[dwAddress - 0x4000 + (iCurrentRomBankNo << 14)], 32);
			printf("Banked ROM read: Bank %02X\n", iCurrentRomBankNo);
		}
		break;
	case 5:	//	else if ((dwAddress >= 0xA000) && (dwAddress <= 0xBFFF))
		if (bHasRam && bRamEnableState) {
			//CopyMemory(Data, &RamData[dwAddress - 0xA000], 32);
			printf("RAM read: Unbanked\n");
		} else {
			//ZeroMemory(Data, 32);
			printf("Failed RAM read: (RAM not present or not active)\n");
		}
		break;
	default:
		printf("Bad read from MBC2 cart, address %04X\n", dwAddress);
	}

	return true;
}



int ReadCartMBC1(uint16_t dwAddress, uint8_t *Data)
{
	
	printf("ReadCartMBC1(%04X)\n",dwAddress);
	printf(">> 13 (%04X)\n",(dwAddress >> 13));
	
	switch (dwAddress >> 13)
	{
	case 0:
	case 1:	//	if ((dwAddress >= 0) && (dwAddress <= 0x3FFF))
		//CopyMemory(Data, &RomData[dwAddress], 32);
		printf("Nonbanked ROM read - MBC1\n");
		break;
	case 2:
	case 3:	//	else if ((dwAddress >= 0x4000) && (dwAddress <= 0x7FFF))
		if (iCurrentRomBankNo >= iNumRomBanks)
		{
			//ZeroMemory(Data, 32);
			printf("Banked ROM read: (Banking Error) Bank %02X (int=%d)\n", iCurrentRomBankNo,iCurrentRomBankNo);
		}
		else
		{
			// for (i=0; i<32; i++) Data[i] = RomData[(dwAddress - 0x4000) + i + (iCurrentRomBankNo * 0x4000)];
			//CopyMemory(Data, &RomData[dwAddress - 0x4000 + (iCurrentRomBankNo << 14)], 32);
			printf("Banked ROM read: Bank %02X (int=%d)\n", iCurrentRomBankNo,iCurrentRomBankNo);
		}
		break;
	case 5:	//	else if ((dwAddress >= 0xA000) && (dwAddress <= 0xBFFF))
		if (bHasRam){ // && bRamEnableState) {
			if (iCurrentRamBankNo >= iNumRamBanks) {
			//	ZeroMemory(Data, 32);
				printf("Failed RAM read: (Banking Error) %02X \n", iCurrentRamBankNo);
			} else {
			//	CopyMemory(Data, &RamData[dwAddress - 0xA000 + (iCurrentRamBankNo << 13)], 32);
				printf("RAM read: Bank %02X\n", iCurrentRamBankNo);
			}
		} else {
			//ZeroMemory(Data, 32);
			printf("Failed RAM read: (RAM not present)\n");
		}
		break;
	default:
		printf("Bad read from MBC1 cart, address %04X\n", dwAddress);
	}

	return true;
}



int WriteCartMBC1(uint16_t dwAddress, uint8_t *Data)
{

	switch (dwAddress >> 13)
	{
	case 0:	//	if ((dwAddress >= 0) && (dwAddress <= 0x1FFF)) // RAM enable
		bRamEnableState = (Data[0] == 0x0A);
		printf("Set RAM enable: %d\n", bRamEnableState);
		break;
	case 1:	//	else if ((dwAddress >= 0x2000) && (dwAddress <= 0x3FFF)) // ROM bank select
		iCurrentRomBankNo &= 0x60;	// keep MSB -> most significant bit?
		iCurrentRomBankNo |= Data[0] & 0x1F;

		// emulate quirk: 0x00 -> 0x01, 0x20 -> 0x21, 0x40->0x41, 0x60 -> 0x61
		if ((iCurrentRomBankNo & 0x1F) == 0) {
			iCurrentRomBankNo |= 0x01;
		}
		printf("Set ROM Bank: %02X\n", iCurrentRomBankNo);
		break;
	case 2:	//	else if ((dwAddress >= 0x4000) && (dwAddress <= 0x5FFF)) // RAM bank select
		if (bMBC1RAMbanking)	{
			iCurrentRamBankNo = Data[0] & 0x03;
			printf("Set RAM Bank: %02X\n", iCurrentRamBankNo);
		}
		else {
			iCurrentRomBankNo &= 0x1F;
			iCurrentRomBankNo |= ((Data[0] & 0x03) << 5); // set bits 5 and 6 of ROM bank
			printf("Set ROM Bank MSB, ROM bank now: %02X\n", iCurrentRomBankNo);
		}
		break;
	case 3:	//	else if ((dwAddress >= 0x6000) && (dwAddress <= 0x7FFF)) // MBC1 mode select
		// this is overly complicated, but it keeps us from having to do bitwise math later
		// Basically we shuffle the 2 "magic bits" between iCurrentRomBankNo and iCurrentRamBankNo as necessary.
		if (bMBC1RAMbanking != (Data[0] & 0x01)) {
			// we should only alter the ROM and RAM bank numbers if we have changed modes
			bMBC1RAMbanking = Data[0] & 0x01;
			if (bMBC1RAMbanking)
			{
				iCurrentRamBankNo = iCurrentRomBankNo >> 5;	// set the ram bank to the "magic bits"
				iCurrentRomBankNo &= 0x1F; // zero out bits 5 and 6 to keep consistency
			}
			else
			{
				iCurrentRomBankNo &= 0x1F;
				iCurrentRomBankNo |= (iCurrentRamBankNo << 5);
				iCurrentRamBankNo = 0x00;	// we can only reach RAM page 0
			}
			printf("Set MBC1 mode: %s\n", bMBC1RAMbanking ? "ROMbanking" : "RAMbanking" );
		}
		else
		{
			printf("Already in MBC1 mode: %s\n", bMBC1RAMbanking ? "ROMbanking" : "RAMbanking" );
		}

		break;
	case 5:	// else if ((dwAddress >= 0xA000) && (dwAddress <= 0xBFFF)) // Write to RAM
		if (bHasRam) // && bRamEnableState)
		{
			printf("RAM write: Bank %02X\n", iCurrentRamBankNo);
			//CopyMemory(&RamData[dwAddress - 0xA000 + (CiCurrentRamBankNo << 13)], Data, 32);
				printf("copy now to offset addr: %04X\n", (dwAddress - 0xA000 + (iCurrentRamBankNo << 13)));
		}
		else
		{
			printf("Failed RAM write: (RAM not present)\n");
		}
		break;
	default:
		printf("Bad write to MBC1 cart, address %04X\n", dwAddress);
	}

	return true;
}



void stageW(int mapper, int dwAddress){
	
		
			printf( "TPak Write:\n" );
			printf( "  Address: %04X\n", dwAddress );


			switch (dwAddress >> 12)
			{
			case 0x8: //	if ((dwAddress >= 0x8000) && (dwAddress <= 0x8FFF))
				if (Data[0] == 0xFE) {
					printf("Cart Disable\n" );
					iEnableState = false;
				}
				else if (Data[0] == 0x84) {
					printf("Cart Enable\n" );
					iEnableState = true;
				}
				else {
					printf("WARNING: Unusual Cart Enable/Disable\n" );
					printf("  Address: " );
					printf("%04X", dwAddress);
					printf("\n" );
					printf("  Data: " );
					printf("%02X", Data[0]);
					printf("\n" );
				}
				break;
			case 0xA: //	if ((dwAddress >= 0xA000) && (dwAddress <= 0xAFFF))
				if (iEnableState == true) {
					iCurrentBankNo = Data[0];
					printf("Set TPak Bank No:%02X\n", Data[0] );
				}
				break;
			case 0xB: //	if ((dwAddress >= 0xB000) && (dwAddress <= 0xBFFF))
				if (iEnableState == true) {
					iCurrentAccessMode = Data[0] & 1;
					iAccessModeChanged = 4;
					printf("Set TPak Access Mode: %04X\n", iCurrentAccessMode);
					if ((Data[0] != 1) && (Data[0] != 0)) {
						printf("WARNING: Unusual Access Mode Change\n" );
						printf("  Address: " );
						printf("%04X",dwAddress);
						printf("\n" );
						printf("  Data: " );
						printf("%02X",Data[0]);
						printf("\n" );
					}
				}
				break;
			case 0xC:
			case 0xD:
			case 0xE:
			case 0xF: //	if (dwAddress >= 0xC000)
				//WriteCartMBC1(((dwAddress & 0xFFE0) - 0xC000) + ((iCurrentBankNo & 3) * 0x4000), Data);

					printf( "### Cart Write: Bank:%i\n", iCurrentBankNo );
					printf( "###    Address:%04X\n", ((dwAddress & 0xFFE0) - 0xC000) + ((iCurrentBankNo & 3) * 0x4000) );


					switch(mapper){
					case 1: WriteCartMBC1(((dwAddress & 0xFFE0) - 0xC000) + ((iCurrentBankNo & 3) * 0x4000), Data); break;
					case 2: WriteCartMBC2(((dwAddress & 0xFFE0) - 0xC000) + ((iCurrentBankNo & 3) * 0x4000), Data); break;
					case 3: WriteCartMBC3(((dwAddress & 0xFFE0) - 0xC000) + ((iCurrentBankNo & 3) * 0x4000), Data); break;
					case 5: WriteCartMBC5(((dwAddress & 0xFFE0) - 0xC000) + ((iCurrentBankNo & 3) * 0x4000), Data); break;
					default: break;
					}
			
				break;
			default:
				printf("WARNING: Unusual Pak Write\n" );
				printf("  Address: %04X\n", dwAddress);
			} // end switch (dwAddress >> 12)

			Data[32] = 0x00; //DataCRC( Data, 32 );
			//bReturn = 0; 
		}



void stageR(int mapper, int dwAddress){


	
			printf( "TPak Read:\n" );
			printf( "  Address: %04X\n", dwAddress );

			switch (dwAddress >> 12)
			{
			case 0x8: //	if ((dwAddress >= 0x8000) && (dwAddress <= 0x8FFF))
				printf( "Query Enable State: 1\n" );

			case 0xB: //	if ((dwAddress >= 0xB000) && (dwAddress <= 0xBFFF))

					printf( "Query Cart. State:" );
					printf( " Inserted, Access Mode 1\n" );
					
				break;
			case 0xC:
			case 0xD:
			case 0xE:
			case 0xF: //	if ((dwAddress >= 0xC000))

					printf( "Cart Read: Bank:%i\n", iCurrentBankNo );
					printf( "    Address:%04X\n", ((dwAddress & 0xFFE0) - 0xC000) + ((iCurrentBankNo & 3) * 0x4000) );

					switch(mapper){
					case 1: ReadCartMBC1(((dwAddress & 0xFFE0) - 0xC000) + ((iCurrentBankNo & 3) * 0x4000), Data); break;
					case 2: ReadCartMBC2(((dwAddress & 0xFFE0) - 0xC000) + ((iCurrentBankNo & 3) * 0x4000), Data); break;
					case 3: ReadCartMBC3(((dwAddress & 0xFFE0) - 0xC000) + ((iCurrentBankNo & 3) * 0x4000), Data); break;
					case 5: ReadCartMBC5(((dwAddress & 0xFFE0) - 0xC000) + ((iCurrentBankNo & 3) * 0x4000), Data); break;
					default: break;
					}
				
				break;
			default:
				printf("WARNING: Unusual Pak Read\n" );
				printf("  Address: %04X\n", dwAddress);
			} // end switch (dwAddress >> 12)



}


int main(int argc, char **argv){

//	memset( Data, 0xFF, 32 );


int cbank = (int)strtol(argv[1], NULL, 16);
int dwAddress = (int)strtol(argv[2], NULL, 16);
int tobank = (int)strtol(argv[3], NULL, 16);

/*
//number = number - 0x80100400 + 0x1000;
//printf("result: 0x%.8x\n", number);
int number;
//number = 80179148 - 0x80077F6C;//number - 0x80100400 + 0x1000;
///number = number + 0x80077F94;
//int dwAddress = 0xC154;



//printf("result: 0x%.8x\n", number);
int i=bank;
//for(i=0;i<125;i++){
	number = ((dwAddress & 0xFFE0) - 0xC000) + ((i & 3) * 0x4000);
	printf("a bank %d result: 0x%.4x\n", i);
	
	printf("b bank %d result: 0x%.4x\n", i, (number >> 13));

int lb=0x02;
		lb &= 0x60;	// keep MSB -> most significant bit?
		lb |= 0x02 & 0x1F;

		printf("c result: 0x%.4x\n", lb);
*/

//	iCurrentRomBankNo &= 0x60;	// keep MSB -> most significant bit?
//	iCurrentRomBankNo |= cbank & 0x1F;

int test=4;
int mbc=2;

if(test==4){ //ram read mbc1

mbc=3;

memset(Data, 0x00, 32);
stageW(mbc, 0xA00C); //prepare for ram enable

memset(Data, 0x0A, 32);
stageW(mbc, 0xC000); //set ram enable for reading/writing

memset(Data, 0x01, 32);
stageW(mbc, 0xA00C); //prepare for rambank switch

memset(Data, 0x01, 32); //00h rombanking 01h rambanking
stageW(mbc, 0xE000); //rambank switch

memset(Data, cbank, 32); //00h ram bank 00-03h
stageW(mbc, 0xC000); //set rambank 00h

printf("\n>>> read ram\n\n");


memset(Data, 0x02, 32);
stageW(mbc, 0xA00C); //prepare for rambank read

memset(Data, 0x00, 32);
stageR(mbc, 0xE000);

printf("\n>>> protect again\n\n");
//protect ram again
memset(Data, 0x00, 32);
stageW(mbc, 0xA00C); //prepare for ram enable

memset(Data, 0x00, 32);
stageW(mbc, 0xC000); //set ram diable for reading/writing


}


if(test==1){

//mbc1

memset(Data, 0x01, 32);
stageW(mbc, 0xA00C);

memset(Data, 0x00, 32);
stageW(mbc, 0xE016);

//upper 2 bits
//0h = +0 int
//1h = +32 int
//2h = +64 int
//3h = +96 int


memset(Data, 0x01, 32);
stageW(mbc, 0xC000);

memset(Data, 0x00, 32);
stageW(mbc, 0xA00C);

memset(Data, cbank, 32); //lower bits bank
stageW(mbc, 0xE100);

memset(Data, 0x01, 32);
stageW(mbc, 0xA00C);

memset(Data, 0x00, 32);
stageR(mbc, 0xC000);

}

if(test==2){
//memset(Data, 0x01, 32);
//stageW(mbc, 0xC000);

memset(Data, 0x00, 32);
stageW(mbc, 0xA00C);

memset(Data, cbank, 32); //lower bits bank
stageW(mbc, 0xE100);

memset(Data, 0x01, 32);
stageW(mbc, 0xA00C);

memset(Data, 0x00, 32);
stageR(mbc, 0xC000);


}

if(test==3){
//memset(Data, 0x01, 32);
//stageW(mbc, 0xC000);

memset(Data, 0x00, 32);
stageW(mbc, 0xA00C);

memset(Data, cbank, 32); //lower bits bank
stageW(mbc, 0xE100);

memset(Data, 0x01, 32);
stageW(mbc, 0xA00C);

memset(Data, 0x00, 32);
stageR(mbc, 0xC000);


}


return 0;
}

